/*
 * config.h
 *
 *	Stellt die jeweiligen Konstanten zur Verfgung, um die Simulation anzupassen
 *
 *  Created on: 05.08.2015
 *      Author: Jun-Patrick Raabe & Kolya Feierabend
 */
#include <stdbool.h>

#ifndef CONFIG_H_
#define CONFIG_H_

/*
 * Gibt an, ob Bilder der Map mitsamt der Kreaturen im Simulationsschritt erstellt werden sollen oder nicht.
 */
extern const bool picturePrinting;

/*
 * Stellt die Groee des Spiefelds in X-Richtung ein
 */
extern const int world_size_x;

/*
 * Stellt die Groee des Spiefelds in Y-Richtung ein
 */
extern const int world_size_y;

/*
 * Stellt die Anzahl der Simulationsschnritte, die bewltigt werden muessen, ein (Dauer).
 */
extern const int sim_duration;

/*
 * Stellt das minimale Alter fuer Menschen, um zum Jaeger zu werden, ein.
 */
extern const int min_fighting_age;

/*
 * Stellt das maximale Alter fuer Menschen, um Jaeger zu bleiben, ein.
 */
extern const int max_fighting_age;

/*
 * Stellt das minimale Alter fuer Menschen ein, um Kinder zu kriegen.
 */
extern const int min_childbirth_age;

/*
 * Stellt das maximale Alter fuer Menschen ein, um Kinder zu kriegen.
 */
extern const int max_childbirth_age;

/*
 * Stellt das Todesalter fuer Menschen ein.
 */
extern const int human_death_age;

/*
 * Stellt die maximale Hungerrate fuer Vampire ein. Wir dieser Wert ueberschritten,
 * so verhungern die Vampire und sterben.
 */
extern const int vampire_max_hunger_rate;

/*
 * Stellt die Anzahl der Vampire zum Simulationsstart ein.
 */
extern const int start_popu_vampire;

/*
 * Stellt die Anzahl der Menschen zum Simulationsstart ein.
 */
extern const int start_popu_human;

/*
 * Stellt die Anzahl der Jaeger zum Simulationsstart ein.
 */
extern const int start_popu_hunter;

/*
 * Dient dazu, ob der Joker Blade in der Simulation auftauchen soll oder nicht.
 */
extern const bool blade_available;

/*
 * Stellt die Wahrscheinlichkeit, dass ein Mensch bei einem Kampf mit einem
 * Vampir ebenfalls zu einem Vampir wird, ein.
 */
extern const int human_to_vampire_percentage;

/*
 * Stellt die Wahrscheinlichkeit, dass ein Jaeger gegen einen Vampir gewinnt, ein.
 */
extern const int hunter_win_percentage;

#endif /* CONFIG_H_ */
