/*
 * generateandset.h
 *
 * Stellt die bentigten Services zur Verfgung, um neue Kreaturen in das Spielfeld zu setzen
 *
 *  Created on: 10.08.2015
 *      Author: Jun-Patrick Raabe & Kolya Feierabend
 */
#include <stdbool.h>
#include "output.h"
#include "parallel.h"

#ifndef GENERATEANDSET_H_
#define GENERATEANDSET_H_
	/*
	 * Ueberprueft und setzt, falls mglich, einen neuen Menschen auf das Spielfeld
	 *
	 *@param x - die aktuelle X-Postion von der aus geschaut werden soll
	 *@param y - die aktuelle Y-Postion von der aus geschaut werden soll
	 *@param sim_step - der aktuelle Simulationsschritt als Integerwert
	 */
	void setNewbornIfPossibile(int x, int y, int sim_step, CounterSumAtSimStep* counterSumAtSimStep);

	/*
	 * Setzt alle Kreaturen auf das Spielfeld
	 */
	void setAllCreatures();

	/*
	 * Gibt die minimale Position zurueck, die durch den Rank bearbeitet wird.
	 */
	int getAllowed_min_x_Pos(int rank, int numprocs);

	/*
	 * Gibt die minimale Position zurueck, die durch den Rank bearbeitet wird.
	 */
	int getAllowed_max_x_Pos(int rank, int numprocs, int allowed_min_x_Pos);
#endif /* GENERATEANDSET_H_ */
