/*
 * output.h
 *
 * Stellt alle Services zur Verfuegung, die benoetigt werden um die Ergebnisse
 * der Simulation aufzuzeichen und auszugeben.
 *
 *  Created on: 07.08.2015
 *      Author: Jun-Patrick Raabe & Kolya Feierabend
 */

#ifndef OUTPUT_H_
#define OUTPUT_H_

	/*
	 * Die Struktur CounterSumAtSimStep faesste alle Counter zu einem bestimmten
	 * Simulationszeitpunkt zusammen.
	 */
	typedef struct{
		int humanCounter;
		int vampireCounter;
		int hunterCounter;
		int bladeCounter;
		int emptyCounter;
	}CounterSumAtSimStep;

	/*
	 * Dient als Zusammenfassung fuer alle Counterstaende zu allen Simulations-
	 * zeitpunkten.
	 */
	extern CounterSumAtSimStep *counterSum;

	/*
	 * Initialisiert alle fuer die Speicherung der Ergebnisse noetigen Variablen.
	 * Hier wird die Varible *counterSum initialisiert.
	 */
	void initResults();

	/*
	 * Gibt eine Zusammenfassung der Simulationsergebnisse auf der Console aus.
	 *
	 * @param start - Startzeitpunkt der Simulation als Integerwert
	 * @param ende - Endzeitpunkt der Simulation als Integerwert
	 */
	void printResultsToConsole(int start, int ende);

	/*
	 * Speichert die Resultate in die Datei output.csv ab.
	 */
	void saveResultsToFile();

	/*
	 * Erstellt ein Bild zum jeweiligen Simulationsschritt im Outputordner
	 *
	 * @param sim_step - der jeweilige Simulationsschritt
	 */
	void createPicture(int sim_step);

	CounterSumAtSimStep initCounterSumAtSimStep();
#endif /* OUTPUT_H_ */
