/*
 * parallel.h
 *
 *  Created on: 07.09.2015
 *      Author: Kolya
 */
#include <mpi.h>

#ifndef PARALLEL_H_
#define PARALLEL_H_


/*
 * Stellen ein Pendant zu den jeweiligen verwendet Structs dar.
 */
MPI_Datatype mpi_counterSumAtSimStep, mpi_creature;

/*
 * Gibt den Rank des aufrufenden Prozeses zurueck.
 */
extern int rank;

/*
 * Gibt die Anzahl der Prozesse zurueck.
 */
extern int numprocs;

/*
 * Gibt die minimale abzuarbeitende X-Position des aufrufenden Prozessen
 * an auf dem Gamefield an.
 */
extern int allowed_min_x_Pos;

/*
 * Gibt die minimale abzuarbeitende X-Position des aufrufenden Prozessen
 * an auf dem Gamefield an.
 */
extern int allowed_max_x_Pos;

/*
 * Initiert alles fuer MPI wichtige.
 */
void init_mpi();

/*
 * Summiert alle Counter in den Counter von Rank 0.
 */
void sumCounter();

/*
 * Fasst das komplette Gamefield in dem von Rank 0 zusammen.
 */
void sumGamefield();

/*
 * Alle Prozesse senden ihre inneren Kannten an ihre jeweiligen Nachbarn.
 */
void sendInnerBoarders();

#endif /* PARALLEL_H_ */
